unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  {$IFDEF MSWINDOWS}
  Registry, shlobj,
  {$ENDIF}
  PPDK_RegFileType in '..\..\..\UNITS\PPDK_RegFileType.pas';

type

  { TfrmMain }
  TfrmMain = class(TForm)
    btnSET: TButton;
    btnCancel: TButton;
    chkINC: TCheckBox;
    chkLPI: TCheckBox;
    chkLPK: TCheckBox;
    chkPP: TCheckBox;
    chkLPR: TCheckBox;
    chkLFM: TCheckBox;
    chkPAS: TCheckBox;
    procedure btnCancelClick(Sender: TObject);
    procedure btnSETClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure CheckRegistry;
  public
    { public declarations }
  end; 

var
  frmMain: TfrmMain;
  Reg: TRegistry;
  bIDE32,
  bIDE64: Boolean;

implementation

{$R *.lfm}

{ TfrmMain }

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Reg);
end;

procedure TfrmMain.btnSETClick(Sender: TObject);
begin
  if(not(bIDE32 or bIDE64))then
  begin
    ShowMessage('Code Typhon Lazarus binaries are not present!');
    exit;
  end;
  if(chkLPI.Checked)then
  begin
    if(bIDE32)then
    begin
      SetFileExt(Reg, '.lpi', 'LazarusProject', 'Lazarus Project Information', 'Open with Lazarus (x32)', 'open', 'c:\lazarus\bin32\lazarus.exe "%1"', 'c:\lazarus\images\LazarusProject.ico', true);
    end;
    if(bIDE64)then
    begin
      SetFileExt(Reg, '.lpi', 'LazarusProject', 'Lazarus Project Information', 'Open with Lazarus (x64)', 'open64', 'c:\lazarus\bin64\lazarus.exe "%1"', 'c:\lazarus\images\LazarusProject.ico', false);
    end;
  end
  else
  begin
		UnSetFileExt(Reg, '.lpi');
  end;
  //
  if(chkLPR.Checked)then
  begin
    if(bIDE32)then
    begin
      SetFileExt(Reg, '.lpr', 'LazarusProjectSource', 'Lazarus Project Main Source', 'Open with Lazarus (x32)', 'open', 'c:\lazarus\bin32\lazarus.exe "%1"', 'c:\lazarus\images\lprfile.ico', true);
    end;
    if(bIDE64)then
    begin
      SetFileExt(Reg, '.lpr', 'LazarusProjectSource', 'Lazarus Project Main Source', 'Open with Lazarus (x64)', 'open64', 'c:\lazarus\bin64\lazarus.exe "%1"', 'c:\lazarus\images\lprfile.ico', false);
    end;
  end
  else
  begin
  	UnSetFileExt(Reg, '.lpr');
  end;
  //
  if(chkLPK.Checked)then
  begin
    if(bIDE32)then
    begin
  		SetFileExt(Reg, '.lpk', 'LazarusPackage', 'Lazarus Package File', 'Open with Lazarus (x32)', 'open', 'c:\lazarus\bin32\lazarus.exe "%1"', 'c:\lazarus\images\lazaruspackage.ico', true);
    end;
    if(bIDE64)then
    begin
  		SetFileExt(Reg, '.lpk', 'LazarusPackage', 'Lazarus Package File', 'Open with Lazarus (x64)', 'open64', 'c:\lazarus\bin64\lazarus.exe "%1"', 'c:\lazarus\images\lazaruspackage.ico', false);
    end;
  end
  else
  begin
  	UnSetFileExt(Reg, '.lpk');
  end;
  //
  if(chkLFM.Checked)then
  begin
    if(bIDE32)then
    begin
  		SetFileExt(Reg, '.lfm', 'LazarusForm', 'Lazarus Form File', 'Open with Lazarus (x32)', 'open', 'c:\lazarus\bin32\lazarus.exe "%1"', 'c:\lazarus\images\LazarusForm.ico', true);
    end;
    if(bIDE64)then
    begin
  		SetFileExt(Reg, '.lfm', 'LazarusForm', 'Lazarus Form File', 'Open with Lazarus (x64)', 'open64', 'c:\lazarus\bin64\lazarus.exe "%1"', 'c:\lazarus\images\LazarusForm.ico', false);
    end;
  end
  else
  begin
  	UnSetFileExt(Reg, '.lfm');
  end;
  //
  if(chkPAS.Checked)then
  begin
    if(bIDE32)then
    begin
  		SetFileExt(Reg, '.pas', 'LazarusUnit', 'Object Pascal Unit', 'Open with Lazarus (x32)', 'open', 'c:\lazarus\bin32\lazarus.exe "%1"', 'c:\lazarus\images\LazarusSource.ico', true);
    end;
    if(bIDE64)then
    begin
  		SetFileExt(Reg, '.pas', 'LazarusUnit', 'Object Pascal Unit', 'Open with Lazarus (x64)', 'open64', 'c:\lazarus\bin64\lazarus.exe "%1"', 'c:\lazarus\images\LazarusSource.ico', false);
    end;
  end
  else
  begin
  	UnSetFileExt(Reg, '.pas');
  end;
  if(chkPP.Checked)then
  begin
    if(bIDE32)then
    begin
  		SetFileExt(Reg, '.pp', 'LazarusFPCUnit', 'Object Pascal Unit', 'Open with Lazarus (x32)', 'open', 'c:\lazarus\bin32\lazarus.exe "%1"', 'c:\lazarus\images\LazarusSource.ico', true);
    end;
    if(bIDE64)then
    begin
  		SetFileExt(Reg, '.pp', 'LazarusFPCUnit', 'Object Pascal Unit', 'Open with Lazarus (x64)', 'open64', 'c:\lazarus\bin64\lazarus.exe "%1"', 'c:\lazarus\images\LazarusSource.ico', false);
    end;
  end
  else
  begin
  	UnSetFileExt(Reg, '.pp');
  end;
  //
  if(chkINC.Checked)then
  begin
    if(bIDE32)then
    begin
  		SetFileExt(Reg, '.inc', 'LazarusInclude', 'Object Pascal Include File', 'Open with Lazarus (x32)', 'open', 'c:\lazarus\bin32\lazarus.exe "%1"', 'c:\lazarus\images\includefile.ico', true);
    end;
    if(bIDE64)then
    begin
  		SetFileExt(Reg, '.inc', 'LazarusInclude', 'Object Pascal Include File', 'Open with Lazarus (x64)', 'open64', 'c:\lazarus\bin64\lazarus.exe "%1"', 'c:\lazarus\images\includefile.ico', false);
    end;
  end
  else
  begin
  	UnSetFileExt(Reg, '.inc');
  end;
  SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
  CheckRegistry;
end;

procedure TfrmMain.btnCancelClick(Sender: TObject);
begin
	Self.Close;
  Application.Terminate;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  Reg := TRegistry.Create();
  CheckRegistry;
  if(FileExists('c:\lazarus\bin32\lazarus.exe'))then
  begin
    bIDE32 := true;
  end;
  if(FileExists('c:\lazarus\bin64\lazarus.exe'))then
  begin
    bIDE64 := true;
  end;
end;

procedure TfrmMain.CheckRegistry;
begin
  chkLPI.Checked := GetFileExt(Reg, '.lpi');//can use DOT before extention
  chkLPR.Checked := GetFileExt(Reg, '.lpr');//..
  chkLPK.Checked := GetFileExt(Reg, '.lpk');//..
  chkLFM.Checked := GetFileExt(Reg, '.lfm');//or NOT
  chkPAS.Checked := GetFileExt(Reg, 'pas'); //..
  chkPP.Checked  := GetFileExt(Reg, 'pp');  //..
  chkINC.Checked := GetFileExt(Reg, 'inc'); //..
end;

end.

